'---------------------------------------------------------
'		file I/O function and variable type definition
'		Copyright (c) 2016 Masamichi Kirikae
'---------------------------------------------------------
#include once "file.bi"
#include once "datatype.bi"

#ifndef false
	#define false	0
	#define true	(not(false))
#endif

#ifndef F_NOERROR
	#define F_NOERROR	0
	#define F_ERROR	1
#endif

#define BigEndian false

#define cprint		print #console,
common shared console as s32	' file handle for console

#define fpseek(fh, fp) 			seek #(fh), ((fp) + 1)
#define fputbyte(fh, dc)		put #(fh), ,cbyte(dc)
#define fputubyte(fh, dc)		put #(fh), ,cubyte(dc)
#define fputint16(fh, dc)		put #(fh), ,cast(s16, (dc))
#define fputuint16(fh, dc)		put #(fh), ,cast(u16, (dc))
#define fputint32(fh, dc)		put #(fh), ,cast(s32, (dc))
#define fputuint32(fh, dc)		put #(fh), ,cast(u32, (dc))
#define fputstringz(fh, st)	put #(fh), ,st

namespace libfio

declare function fgetbyte(byref fh as s32) as s8
declare function fgetubyte(byref fh as s32) as u8
declare function fgetint16(byref fh as s32) as s16
declare function fgetuint16(byref fh as s32) as u16
declare function fgetint32(byref fh as s32) as s32
declare function fgetuint32(byref fh as s32) as u32
declare function fgetstring(byref fh as s32, byref n as s32) as string
declare function fgetstringz(byref fh as s32) as string
declare function change_filename_ext(byref filename as string, byref ext as string) as string
declare function get_filename_ext(byref filename as string) as string
declare function get_directory(byref filename as string) as string
declare function get_filename_only(byref filename as string) as string

end namespace
