'----------------------------------------------------------
'	string treat functions 
'	Copyright (c) 2019 Masamichi Kirikae
'----------------------------------------------------------
#include "libstring.bi"

namespace libstr
	
function strform_val(fill as string, leftlength as s32, rightlength as s32, src as double) as string
	dim as s32 lg, llg, rlg, i, dotpoint
	dim as string st, lst, rst
	st = ltrim(str(src))
	lg = len(st)
	for i = 1 to lg
		if (mid(st, i, 1) = ".") then
			dotpoint = i
			exit for
		endif
	next
	
	if (dotpoint > 1) then
		lst = left(st, dotpoint - 1)
		rst = right(st, lg - dotpoint)
		llg = len(lst)
		rlg = len(rst)
	else
		lst =st
		llg = lg
		rst = ""
		rlg = 0
	endif
	
	if (llg > leftlength) then
		lst = "!" + lst
	else
		lst = string(leftlength - llg, fill) + lst
	endif
	
	if (rightlength > 1) then
		if (rlg = 0) then
			rst = string(rightlength, "0")
		elseif (rlg <= rightlength) then
			rst = rst + string(rightlength - rlg, "0")
		elseif (rlg > rightlength) then
			rst = left(rst, rightlength)
		endif
		st = lst + "." + rst
		return(st)
	else
		return(lst)
	endif
end function

function strform_str(byref align as string, byref length as s32, byval src as string) as string
	dim as s32 lg, i, n
	dim as string st, rst

	src = trim(src)
	lg = len(src)
	if (lg > length) then
		st = "!" + src
		return(st)
	endif
	
	n = length - lg
	st = space(n)
	select case lcase(align)
		case "left"
			rst = src + st
		case "right"
			rst = st + src
		case else
			rst = src + st
	end select
	
	return(rst)
	
end function

function format_hms(tms as s32) as string
	dim as s32 h, m, s
	dim as string hs, ms, ss, stime
	h = tms \ 3600
	m = (tms - h * 3600) \ 60
	s = tms mod 60
	hs = str(h)
	select case len(hs)
		case 0
			hs = "00"
		case 1
			hs = "0" + hs
		case else
	end select
	ms = str(m)
	select case len(ms)
		case 0
			ms = "00"
		case 1
			ms = "0" + ms
		case else
	end select
	ss = str(s)
	select case len(ss)
		case 0
			ss = "00"
		case 1
			ss = "0" + ss
		case else
	end select
	stime = hs + ":" + ms + ":" + ss	
	return(stime)	
end function

end namespace
