'-------------------------------------------------
'		extract/rebuild peg_pc, g_peg_pc file
'		Copyright (c) 2016 Masamichi Kirikae
'-------------------------------------------------
#include once "crt/string.bi"
#include once "datatype.bi"
#include once "dir.bi"
#include once "fileio.bi"
#include once "pnglib.bi"
#include once "squish.bi"
#include once "ddslib.bi"
#include once "xml.bi"

#ifndef F_NOERROR
	#define F_NOERROR	0
	#define F_ERROR	1
#endif

#ifndef arraycopy
	#define arraycopy(dest, src, size) memcpy(@dest(0), @src(0), sizeof((dest(0))) * (size - 1))
#endif

type peg_pc_director_data
	check_imagesize_difference as s32
	suppress_extracted as s32
end type

namespace peg_pc
	
	type peg_header
		magic 			as string*4		' must be "GEKV"
		version 		as u16		' must be 10
		unknown06 		as u16
		filesize 		as u32
		datafilesize 	as u32
		entrycount 		as u16		' number of textures
		unknown12 		as u16
		framecount 		as u16		' usually 1
		unknown16 		as u16
	end type
	
	type peg_frame
		offset			as u32		' raw image data offset address in gpeg_pc file
		width			as u16		' texture width
		height			as u16		' texture height
		format			as u16		' texture format
		unknown0A 		as u16
		unknown0C 		as u32
		frames			as u16		' usually 1
		unknown12		as u32
		unknown16		as u32
		unknownflags	as u8
		mipmapcount		as u8			' mipmap level
		size			as u32		' raw image size in gpeg_pc file
		unknown20		as u32
		unknown24		as u32
		unknown28		as u32
		unknown2C		as u32
	end type

	declare sub init_peg()	
	declare function save_dds_raw(byref fname as string, imgw as s32, imgh as s32, rawdata() as u8, rawsize as s32, pixform as s32, mipmapcount as s32) as s32
	declare sub write_pegheader(fh as s32, byref peg as peg_header)
	declare sub read_pegframe(fh as s32, byref frame as peg_frame)
	declare sub write_pegframe(fh as s32, byref frame as peg_frame)
	declare function get_pegname(byref fname as string) as string
	declare function get_pegdata(byref filename as string, byref peg as peg_header, names() as string, frames() as peg_frame) as s32
	declare function get_image_gpeg(byref gpeg_name as string, image_rgba() as u8, peg as peg_header, frames() as peg_frame, entry as s32) as s32
	declare function extract_peg(byref filename as string, byref destpath as string) as s32
	declare function rebuild_peg(byref filename as string, byref destpath as string) as s32

	common shared peg_director as peg_pc_director_data
	
end namespace