'-------------------------------------------------
'		Saints Row2 pack/unpack library
'		Copyright (c) 2019 Masamichi Kirikae
'-------------------------------------------------
#include once "sr2packfile.bi"

namespace SaintsRow2_FileFormats

function swap32(byval value as u32) as u32
	dim as s8 ptr byteptr
	byteptr = cast(s8 ptr, @value)
	swap byteptr[0], byteptr[3]
	swap byteptr[1], byteptr[2]
	return(value)
end function

function swap32(value as s32) as s32
	dim as s8 ptr byteptr
	byteptr = cast(s8 ptr, @value)
	swap byteptr[0], byteptr[3]
	swap byteptr[1], byteptr[2]
	return(value)
end function

function readmem32(byval buffer as s8 ptr) as s32
	dim as s32 value
	dim as s32 ptr siptr
	siptr = cast(s32 ptr, buffer)
	value = *siptr
	return(value)
End Function

function getstringz(buffer() as s8, offset as s32) as string
	dim as s8 ch
	dim as s32 i = offset
	dim retstr as string
	do  
		ch = buffer(i)
		if (ch = 0) then exit do
		retstr += chr(ch)
		i += 1
	loop
	return(retstr)
end function

function readalign(fh as s32, align as s32) as s32
	dim as u64 fpos
	dim as s8 ch
	fpos = loc(fh)
	do while ((fpos mod align) <> 0)
		if (eof(fh)) then return(true)
		get #fh, ,ch
		fpos+=1
	loop
	return(false)
end function

function writealign(fh as s32, align as s32) as s32
	dim as u64 fpos
	dim as s8 ch = 0
	fpos = loc(fh)
	do while ((fpos mod align) <> 0)
		put #fh, ,ch
		fpos+=1
	loop
	return(false)
end function

function sizealign(size as s32, align as s32) as s32
	dim as s32 n
	n = size
	do	while((n mod align) <> 0)
		n+=1
	loop
	return(n)
end function

sub MergeSort_FullFileName(arr() as FileInfomations, first as s32, last as s32)
	if first < last then
		dim length as s32 = last - first + 1
		dim middle as s32 = first + (last - first) \ 2
		MergeSort_FullFileName(arr(), first, middle)
		MergeSort_FullFileName(arr(), middle+1, last)
		redim temp(0 to length - 1) as FileInfomations
		for i as s32 = 0 to length - 1
			temp(i) = arr(first + i)
		next
		dim mptr as s32 = 0
		dim sptr as s32 = middle - first + 1
		for i as s32 = 0 to length - 1
			if sptr > last - first then
				arr(i + first) = temp(mptr)
				mptr += 1
			elseif mptr > middle - first then
				arr(i + first) = temp(sptr)
				sptr += 1
			elseif temp(mptr).FullFileName > temp(sptr).FullFileName then
				arr(i + first) = temp(sptr)
				sptr += 1
			else
				arr(i + first) = temp(mptr)
				mptr += 1
			end if
      next
   end if   
end sub

sub MergeSort_FileExt(arr() as FileInfomations, first as s32, last as s32)
	if first < last then
		dim length as s32 = last - first + 1
		dim middle as s32 = first + (last - first) \ 2
		MergeSort_FileExt(arr(), first, middle)
		MergeSort_FileExt(arr(), middle+1, last)
		redim temp(0 to length - 1) as FileInfomations
		for i as s32 = 0 to length - 1
			temp(i) = arr(first + i)
		next
		dim mptr as s32 = 0
		dim sptr as s32 = middle - first + 1
		for i as s32 = 0 to length - 1
			if sptr > last - first then
				arr(i + first) = temp(mptr)
				mptr += 1
			elseif mptr > middle - first then
				arr(i + first) = temp(sptr)
				sptr += 1
			elseif temp(mptr).FileExt > temp(sptr).FileExt then
				arr(i + first) = temp(sptr)
				sptr += 1
			else
				arr(i + first) = temp(mptr)
				mptr += 1
			end if
      next
   end if   
end sub

sub MergeSort_FileSize(arr() as FileInfomations, first as s32, last as s32)
	if first < last then
		dim length as s32 = last - first + 1
		dim middle as s32 = first + (last - first) \ 2
		MergeSort_FileExt(arr(), first, middle)
		MergeSort_FileExt(arr(), middle+1, last)
		redim temp(0 to length - 1) as FileInfomations
		for i as s32 = 0 to length - 1
			temp(i) = arr(first + i)
		next
		dim mptr as s32 = 0
		dim sptr as s32 = middle - first + 1
		for i as s32 = 0 to length - 1
			if sptr > last - first then
				arr(i + first) = temp(mptr)
				mptr += 1
			elseif mptr > middle - first then
				arr(i + first) = temp(sptr)
				sptr += 1
			elseif temp(mptr).FileSize > temp(sptr).FileSize then
				arr(i + first) = temp(sptr)
				sptr += 1
			else
				arr(i + first) = temp(mptr)
				mptr += 1
			end if
      next
   end if   
end sub


function separate_filenameextention(byval filename as string, byref fname as string, byref extention as string) as s32
	dim i as s32, lg as s32, pn as s32
	lg = len(filename)
	for i = lg to 1 step -1
		if mid(filename, i, 1) = "." then
			pn = i
			exit for
		endif
	next
	if (pn > 1) then
		fname = left(filename, pn - 1)
		extention = right(filename, lg - pn)
	else
		fname = ""
		extention = ""
		return(true)
	endif
	return(false)
end function

function get_filenumber(path as string) as s32
	dim as string fpath, filename
	dim as s32 fnumber
	fpath = path + "\*.*"
	filename = dir(fpath, fbArchive)
	do while (filename <> "")
		fnumber+=1
		filename = dir()
	loop
	return(fnumber)
end function

function get_fileinfo(fileinfo() as FileInfomations, path as string, filenum as s32) as s32
	dim as string fpath, filename, fname, fext
	dim as s32 i, fnumber, filesize, retval
	redim fileinfo(filenum - 1) as FileInfomations
	
	fpath = path + "\*.*"
	filename = dir(fpath, fbArchive)
	do while (filename <> "")
		retval = separate_filenameextention(filename, fname, fext)
		'	check for valid filename
		if (not retval) then
			fileinfo(fnumber).FullFileName = filename
			fileinfo(fnumber).FileName = fname
			fileinfo(fnumber).FileExt = fext
			fileinfo(fnumber).FileSize = filelen(path + "\" + filename)
			fnumber+=1
		endif
		filename = dir()
	loop
	return(fnumber)
end function

function make_NamesDictionary(fileinfo() as FileInfomations, filenum as s32, fnamedict() as string) as s32
	dim as s32 i, n, flag, namenum, offset
	dim as string namedict(filenum - 1)

	' sort by filename
	MergeSort_FullFileName(fileinfo(), 0, filenum - 1)

	'	make filename dictionary
	namenum = 0
	namedict(namenum) = fileinfo(0).FileName
	for i = 1 to filenum - 1
		if ( fileinfo(i).FileName <> namedict(namenum) ) then
			namenum+=1
			namedict(namenum) = fileinfo(i).FileName
		endif
	next
	namenum+=1
		
	for i = 0 to namenum - 1
		namedict(i) += chr(0)	'	to zstring
	next

	dim nameoffset(namenum-1) as s32

	'	make filename dictionary offset
	offset = 0
	nameoffset(0) = offset
	for i = 1 to namenum - 1
		offset += len(namedict(i-1))
		nameoffset(i) = offset
	next
	
	'	set fileinfo().NameOffset
	n = 0
	for i = 0 to filenum - 1
		do
			if ( fileinfo(i).FileName = rtrim(namedict(n), chr(0)) ) then
				fileinfo(i).NameOffset = nameoffset(n)
				exit do
			else
				n+=1
			endif
		loop
	next
	
	redim fnamedict(namenum - 1) as string
	for i = 0 to namenum - 1
		fnamedict(i) = namedict(i)
	next
	
	return(namenum)
	
end function

function make_ExtsDictionary(fileinfo() as FileInfomations, filenum as s32, extnamedict() as string) as s32
	dim as s32 i, n, flag, extnum, offset
	dim as string extdict(filenum - 1)
	
	'	make extention dictionary
	' sort by ExtName
	
	MergeSort_FileExt(fileinfo(), 0, filenum - 1)
	'	make Extname dictionary
	extnum = 0
	extdict(extnum) = fileinfo(0).FileExt
	for i = 1 to filenum - 1
		if ( fileinfo(i).FileExt <> extdict(extnum) ) then
			extnum+=1
			extdict(extnum) = fileinfo(i).FileExt
		endif
	next
	extnum+=1
		
	for i = 0 to extnum - 1
		extdict(i) += chr(0)	'	to zstring
	next
	
	dim extoffset(extnum-1) as s32

	'	make extention dictionary offset
	offset = 0
	extoffset(0) = offset
	for i = 1 to extnum - 1
		offset += len(extdict(i-1))
		extoffset(i) = offset
	next
	
	'	set fileinfo().ExtOffset
	n = 0
	for i = 0 to filenum - 1
		if ( fileinfo(i).FileExt = rtrim(extdict(n), chr(0)) ) then
			fileinfo(i).ExtOffset = extoffset(n)
		else
			n+=1
			fileinfo(i).ExtOffset = extoffset(n)
		endif
	next

	redim extnamedict(extnum - 1) as string
	for i = 0 to extnum - 1
		extnamedict(i) = extdict(i)
	next
	
	return(extnum)
	
end function

'---------------------------------------
'	Unpack files in the vpp_pc to folder
'---------------------------------------
function UnpackFile(zsrcfilename as zstring, zdestpath as zstring) as s32
	dim header as PackageHeader
	dim as s32 i, j, fh, fh2, size, retval
	dim as u64 amount, bytesread
	dim as u32 Version
	
	dim as string srcfilename = zsrcfilename
	dim as string destpath = zdestpath
	
	'	open source file (.vpp_pc file)
	fh = freefile
	open srcfilename for binary access read as #fh

	'	read header
	get #fh, , header , , bytesread
	if (bytesread <> sizeof(header)) then file_Exception

	retval = readalign(fh, 2048)
	if (retval) then file_Exception
	
	'	Magic
	if (header.Magic = &H51890ACE) then
		BigEndian = false
	elseif (header.Magic = &HCE0A8951) then
		bigEndian = true
		'	swap bytes
		header.Version						= swap32(header.Version)
		header.Flags						= swap32(header.Flags)
		header.IndexCount					= swap32(header.IndexCount)
		header.PackageSize				= swap32(header.PackageSize)
		header.IndexSize					= swap32(header.IndexSize)
		header.NamesSize					= swap32(header.NamesSize)
		header.ExtentionsSize			= swap32(header.ExtentionsSize)
		header.UncompressedDataSize	= swap32(header.UncompressedDataSize)
		header.CompressedDataSize		= swap32(header.CompressedDataSize)
	endif
	
	'	read index
	dim as s8 indexBuffer(header.IndexSize - 1)

	get #fh, , indexBuffer(), , bytesread
	if (bytesread <> header.IndexSize) then file_Exception

	retval = readalign(fh, 2048)
	if (retval) then file_Exception
	
	'	read name
	dim as s8 namesBuffer(header.NamesSize - 1)

	get #fh, , namesBuffer(), , bytesread
	if (bytesread <> header.NamesSize) then file_Exception
	
	retval = readalign(fh, 2048)
	if (retval) then file_Exception

	'	read extention
	dim as s8 extentionsBuffer(header.ExtentionsSize - 1)

	get #fh, , extentionsBuffer(), , bytesread
	if (bytesread <> header.ExtentionsSize) then file_Exception

	retval = readalign(fh, 2048)
	if (retval) then file_Exception
	 
	dim as s32 baseoffset
	baseoffset = cast(s32, loc(fh))

	'	read entry from index, name, extention
	dim entry as PackageEntry
	dim as s32 offset 
	dim as string fname, fext, filename
	for i = 0 to header.IndexCount - 1
		offset = i * 28

		entry.NameOffset 			= readmem32(@indexbuffer(offset))
		entry.ExtentionOffset	= readmem32(@indexbuffer(offset + &h04))
		entry.Unknown08			= readmem32(@indexbuffer(offset + &H08))
		entry.Offset				= readmem32(@indexbuffer(offset + &H0C))
		entry.UncompressedSize	= readmem32(@indexbuffer(offset + &H10))
		entry.CompressedSize		= readmem32(@indexbuffer(offset + &H14))
		entry.Unknown1C			= readmem32(@indexbuffer(offset + &H18))

		if (bigEndian = true) then
			entry.NameOffset			= swap32(entry.NameOffset)
			entry.ExtentionOffset	= swap32(entry.ExtentionOffset)
			entry.Unknown08			= swap32(entry.Unknown08)
			entry.Offset				= swap32(entry.Offset)
			entry.UncompressedSize	= swap32(entry.UncompressedSize)
			entry.CompressedSize		= swap32(entry.CompressedSize)
			entry.Unknown1C			= swap32(entry.Unknown1C)
		endif
		
		if ((header.Flags and 1) = 1) then
			entry.Offset = baseOffset
			baseOffset += entry.CompressedSize '	Align 2048?
		else
			entry.Offset += baseOffset
		endif	

		if ( (entry.Unknown08 <> 0) or (entry.Unknown1C <> 0) ) then
			file_Exception
		endif
		if ( ((header.Flags and 1) <> 1) and (entry.CompressedSize <> -1) ) then
			file_Exception
		endif
		
		'	write file
		fname = getstringz(namesBuffer(), entry.NameOffset)
		fext = getstringz(extentionsBuffer(), entry.ExtentionOffset)

		filename = destpath + "\" + fname + "." + fext
		fh2 = freefile
		
		redim as s8 dataBuffer(entry.UncompressedSize-1)
		open filename for binary access write as #fh2
		
		seek fh, entry.Offset + 1
		get #fh, ,databuffer()		
		put #fh2, ,databuffer()
		
		close #fh2
		
	next
	
	close #fh
	return(false)
	
end function

'---------------------------------------
'	Pack files to vpp_pc
'---------------------------------------
function PackFile(zsrcpath as zstring, zdestpath as zstring) as s32
	dim header as PackageHeader
	dim as string srcfile
	dim as s32 fh, fh2
	dim as s32 i, j, n, retval, offset, size
	dim as s32 filenum, namenum, extnum

	dim as string srcpath = zsrcpath
	dim as string destpath = zdestpath

	redim fileinfo(any) as FileInfomations
	redim namesDictionary(any) as string
	redim extsDictionary(any) as string

	filenum = get_filenumber(srcpath)
	filenum = get_fileinfo(fileinfo(), srcpath, filenum)

	if (filenum = 0) then file_Exception
	dim entry(filenum - 1) as PackageEntry

	'	make ext dictionary
	extnum  = make_ExtsDictionary(fileinfo(), filenum, extsDictionary())
	'	make name dictionary
	namenum = make_NamesDictionary(fileinfo(), filenum, namesDictionary())	

	'	set header value
	header.Magic = &H51890ACE
	header.Version = 4
	header.IndexCount = filenum
	header.PackageSize = 0
	header.IndexSize = filenum * 28

	'	calc namesDictionary size
	size = 0
	for i = 0 to namenum - 1
		size +=	len(namesDictionary(i))
	next

	'	convert string array to s8 array
	n = 0
	dim as s8 namesBuffer(size - 1)
	for i = 0 to namenum - 1
		for j = 0 to len(namesDictionary(i)) - 1
			namesBuffer(n) = cast( s8, asc(namesDictionary(i), j+1) )
			n+=1
		next
	next

	header.NamesSize = size

	'	calc extsDictionary size
	size = 0
	for i = 0 to extnum - 1
		size +=	len(extsDictionary(i))
	next

	header.ExtentionsSize = size

	'	convert string array to s8 array
	n = 0	
	dim as s8 extsBuffer(size - 1)
	for i = 0 to extnum - 1
		for j = 0 to len(extsDictionary(i)) - 1
			extsBuffer(n) = cast( s8, asc(extsDictionary(i), j+1) )
			n+=1
		next
	next

	header.UncompressedDataSize = 0
	header.CompressedDataSize = -1

	'	open destination file
	fh = freefile
	open destpath for binary access write as #fh

	'	write header (incomplete)
	put #fh, ,header
	writealign(fh, 2048)

	'	write entries
	offset = 0
	for i = 0 to filenum - 1
		entry(i).NameOffset			= fileinfo(i).NameOffset
		entry(i).ExtentionOffset	= fileinfo(i).ExtOffset
		entry(i).Unknown08			= 0
		entry(i).Offset				= offset	
		entry(i).UncompressedSize	= fileinfo(i).FileSize
		entry(i).CompressedSize		= -1
		entry(i).Unknown1C			= 0
		offset += sizealign(entry(i).UncompressedSize, 16)
		put #fh, ,entry(i)
	next
	writealign(fh, 2048)

	'	write name dictionary
	put #fh, ,namesBuffer()
	writealign(fh, 2048)
	
	'	write ext dictionary
	put #fh, ,extsBuffer()
	writealign(fh, 2048)

	' write each file data
	dim as string fname, fext, filename
	
	offset = loc(fh)
	for i = 0 to filenum - 1

		fname = getstringz(namesBuffer(), entry(i).NameOffset)
		fext = getstringz(extsBuffer(), entry(i).ExtentionOffset)
		filename = srcpath + "/" + fname + "." + fext

		dim as s8 dataBuffer(entry(i).UncompressedSize - 1)

		fh2 = freefile
		open filename for binary access read as #fh2	
		get #fh2, ,dataBuffer()
		close #fh2
		
		put #fh, ,dataBuffer()
		writealign(fh, 16)
		
	next
	
	'	set right value to header
	header.PackageSize = loc(fh)
	header.UncompressedDataSize = header.PackageSize - offset

	'	rewrite complete header
	seek #fh, 1
	put #fh, ,header
	
	close #fh
	
	return(false)

end function

end namespace