'-------------------------------------------------
'		Saints Row2 pack/unpack library
'		Copyright (c) 2019 Masamichi Kirikae
'-------------------------------------------------
#include once "dir.bi"
#include once "file.bi"
#include once "datatype.bi"

#ifndef file_Exception
	#macro file_Exception
		close: return(true)
	#endmacro
#endif

namespace SaintsRow2_FileFormats

	dim shared BigEndian as boolean
	
	type packageheader
		as u32	Magic
		as u32	Version
		as u8	NotInUse08(324)
		as u32	Flags
		as s32	IndexCount
		as s32	PackageSize
		as s32	IndexSize
		as s32	NamesSize
		as s32	ExtentionsSize
		as s32	UncompressedDataSize
		as s32	CompressedDataSize
	end type
	
	type PackageEntry
		as s32	NameOffset
		as s32	ExtentionOffset
		as u32	Unknown08
		as s32	Offset
		as s32	UncompressedSize
		as s32	CompressedSize
		as u32	Unknown1C
	end type
	
	type FileInfomations
		FullFileName		as string
		FileName				as string
		NameOffset			as s32
		FileExt				as string
		ExtOffset			as s32
		FileSize				as s32
	end type

	declare function UnpackFile(srcpath as zstring, destpath as zstring) as s32
	declare function PackFile(srcpath as zstring, destpath as zstring) as s32

	declare function spap32 overload (value as u32) as u32
	declare function swap32 overload (value as s32) as s32
	declare function readmem32(byval buffer as s8 ptr) as s32
	declare function getstringz(buffer() as s8, offset as s32) as string
	declare function readalign(fh as s32, align as s32) as s32
	declare function writealign(fh as s32, align as s32) as s32
	declare function sizealign(size as s32, align as s32) as s32

	declare sub MergeSort_FullFileName(arr() as FileInfomations, first as s32, last as s32)
	declare sub MergeSort_FileExt(arr() as FileInfomations, first as s32, last as s32)
	declare sub MergeSort_FileSize(arr() as FileInfomations, first as s32, last as s32)

	declare function separate_filenameextention(byval filename as string, byref fname as string, byref extention as string) as s32
	declare function get_filenumber(path as string) as s32
	declare function get_fileinfo(fileinfo() as FileInfomations, path as string, filenum as s32) as s32
	declare function make_NamesDictionary(fileinfo() as FileInfomations, filenum as s32, fnamedict() as string) as s32
	declare function make_ExtsDictionary(fileinfo() as FileInfomations, filenum as s32, extnamedict() as string) as s32

end namespace