'-------------------------------------------------
'		Windows fileopen/save/select folder
'		Copyright (c) 2019 Masamichi Kirikae
'-------------------------------------------------
#include "winfilefolder.bi"

function FileOpenSaveDialog(iMode as long, byval szTitle as zstring ptr, byval szInitialDir as zstring ptr, byval _szFilter as zstring ptr, byval iFlags as DWORD, byval szName as zstring ptr) as string
	dim ofn as OPENFILENAME
	dim buff as ZString*260
	dim sz_Filter as ZString Ptr
	dim iIndex as ulong

	ofn.lStructSize = SizeOf(OPENFILENAME)
	ofn.hwndOwner = NULL
	ofn.hInstance = GetModuleHandle(NULL)
	ofn.lpstrInitialDir = szInitialDir
	buff = String(260,0)
	if szName then
		strcpy(buff,szName)
	endif
	ofn.lpstrFile = @buff
	ofn.nMaxFile = 260
	sz_Filter = malloc(StrLen(_szFilter)+2)
	StrCpy(sz_Filter,_szFilter)
	sz_Filter[StrLen(sz_Filter)+1] = 0
	for iIndex = 0 To strlen(sz_Filter) - 1
		if sz_Filter[iIndex] = asc("|") then sz_Filter[iIndex] = 0
	next iIndex
	ofn.lpstrFilter = sz_Filter
	ofn.lpstrTitle = szTitle
	if iFlags = 0 then
		ofn.Flags = iFlags
	endif
	if iMode = 0 then
		if GetOpenFileName(@ofn) then Function =  buff
	else
		if GetSaveFileName(@ofn) then Function =  buff
	EndIf
	free(sz_Filter)
end function

function FileSelectFolder_callback (Byval hwndbrowse as HWND, Byval uMsg as ulong, byval lp as LPARAM, byval lpData as LPARAM) as long
	If uMsg = BFFM_INITIALIZED Then
		dim fp as FOLDER_PROPS ptr
		fp = cast(FOLDER_PROPS ptr, lpData)
		if fp Then
			if (*fp).lpszInitialFolder then
				If (*fp).lpszInitialFolder[0] <> 0   Then
				' set initial directory
				SendMessage(hwndbrowse, BFFM_SETSELECTION, TRUE, Cast(LPARAM,fp->lpszInitialFolder))
				endif
			endif
			if fp->lpszTitle then
				If (fp->lpszTitle[0] <>0) Then
				'   // set window caption
				 SetWindowText(hwndbrowse, fp->lpszTitle)
				endif
			endif
		endif	
	endif
	return 0
end function

function FileSelectFolder (byref title as string = "Choose A Folder", byval nCSIDL as long, iFlags as ulong, byref sz_InitialDir as string) As string
	dim bi as BROWSEINFO
	dim pidl as LPITEMIDLIST
	dim ret as HRESULT
	dim physpath as zstring * MAX_PATH
	dim dispname as zstring * MAX_PATH
	dim fp as FOLDER_PROPS
	
	iFlags = BIF_EDITBOX
	bi.hwndOwner = HWND_DESKTOP
	If nCSIDL then
		ret = SHGetSpecialFolderLocation(HWND_DESKTOP, nCSIDL, cast(LPITEMIDLIST ptr, bi.pidlRoot))
		'ret = SHGetFolderLocation(HWND_DESKTOP, nCSIDL, NULL, NULL, @bi.pidlRoot)
	else
		'ret = SHGetSpecialFolderLocation(HWND_DESKTOP, CSIDL_DESKTOP, @bi.pidlRoot)
		ret = SHGetFolderLocation(HWND_DESKTOP, CSIDL_DESKTOP , NULL, NULL, cast(LPITEMIDLIST ptr, bi.pidlRoot))
	endif
	
	fp.lpszTitle = strptr(Title)
	fp.lpszInitialFolder = strptr(sz_InitialDir)
	fp.ulFlags = iFlags
	
	bi.pszDisplayName = @dispname
	bi.lpszTitle = strptr(title)
	bi.ulFlags = iFlags
	bi.lpfn = @FileSelectFolder_callback
	bi.lParam = cast(LPARAM, varptr(fp))
	bi.iImage = 0
	
	pidl = SHBrowseForFolder(@bi)

	if pidl <> 0 then
		if SHGetPathFromIDList(pidl, physpath) = 0 then
			Function = ""
		else
			Function = physpath
		endif
		CoTaskMemFree(cast(LPITEMIDLIST ptr, pidl))
	else
		Function = ""
	endIf
	
	CoTaskMemFree(cast(LPITEMIDLIST ptr, bi.pidlRoot))
end function
