'----------------------------------------------------------
'	Simple XML format support 
'	Copyright (c) 2016 Masamichi Kirikae
'----------------------------------------------------------
#include once "datatype.bi"
#include once "fileio.bi"

#ifndef null
	#define null	0
#endif

namespace xml

	#define XML_NO_ERROR				0
	#define XML_ELEMENT_ONLY			1
	#define XML_ELEMENT_WITH_VALUE	2
	#define XML_NO_ELEMENT			4
	#define XML_ERROR_FILE_HANDLE	8
	#define XML_ERROR_SYNTAX			16
	
	#define xml_header "<?xml version=""1.0"" encoding=""utf-8\""?>"
	#define stack_depth 16
	
	type xml_stack_package
		depth as s32
		ename(stack_depth) as string
	end type
	
	dim shared xml_stack as xml_stack_package
	dim shared xml_fh as s32
	
	declare sub push(byref st as string)
	declare function pop() as string
	declare sub new_element(byref ename as string)
	declare sub close_element()
	declare sub write_single_element(byref ename as string, byref value as string)
	declare function new_doc(byref filename as string, byref doctype as string) as s32
	declare function close_doc() as s32
	declare function read_doc(byref filename as string) as s32
	declare function get_element_status(byref st as string) as s32
	declare sub get_element_name(byref st as string, byref ename as string)
	declare sub get_element_and_value(byref st as string, byref ename as string, byref value as string)
	declare function read_element(byref ename as string, byref value as string) as s32

end namespace
